﻿Type=Activity
Version=1.80
FullScreen=False
IncludeTitle=True
@EndOfDesignText@
'Activity module
Sub Process_Globals
	'These global variables will be declared once when the application starts.
	'These variables can be accessed from all modules.
	Dim contentId As Int
	Dim isAmaal As Int
	Dim iMonth As Int
	Dim Parser As SaxParser
	Dim web As PhoneIntents
	Dim hc As HttpClient
	Dim req As HttpRequest
End Sub

Sub Globals
	'These global variables will be redeclared each time the activity is created.
	'These variables can only be accessed from this module.
	Dim lstCategory As ListView
	Dim pnlContent As Panel
	Dim pnlHead As Panel
	Dim pnlSearch As Panel
	Dim btnSearch, btnExit As Button
	Dim txtSearch As EditText
	Dim imgLogo As ImageView
	Dim imgLogoRight As ImageView
	Dim Title, Link, PubDate, Description As String
End Sub

Sub Activity_Create(FirstTime As Boolean)
	pnlContent.Initialize("")
	pnlHead.Initialize("")
	
	If Main.categoryId = 16 Then 
		Activity.AddView(pnlHead, 2dip, 2dip, 100%x, 65dip)
		Activity.AddView(pnlContent, 2dip, pnlHead.Height + 5, 100%x, 100%y - 65dip)
	Else
		Activity.AddView(pnlHead, 2dip, 2dip, 100%x, 105dip)
		Activity.AddView(pnlContent, 2dip, pnlHead.Height + 5, 100%x, 100%y - 105dip)
	End If
	
	If Main.categoryId = 13 Then
		File.MakeDir(File.DirRootExternal, "siatquran")
	End If
	
	Activity.Title = "Shia Isna Asheri Toolkit"
	pnlHead.LoadLayout("Search")
	pnlContent.LoadLayout("Category")
	
	If Main.categoryId = 16 Then
		NewsFeed
	Else
		FillListView(Main.categoryId, "")
	End If
End Sub

Sub Activity_Resume
	InitLayout
End Sub

Sub Activity_Pause (UserClosed As Boolean)

End Sub

Sub NewsFeed()
	lstCategory.Clear
	
	Parser.Initialize
	hc.Initialize("hc")
	req.InitializeGet("http://www.abna.ir/RSS.asp?lang=3")
	hc.Execute(req, 1)
End Sub

Sub hc_ResponseSuccess(Response As HttpResponse, TaskId As Int)
	Response.GetAsynchronously("GetRSS", File.OpenOutput(File.DirInternal, "RSS.xml", False), True, TaskId)
End Sub

Sub hc_ResponseError(Response As HttpResponse, Reason As String, StatusCode As Int, TaskId As Int)
	If Response <> Null Then
		Msgbox("Error: " & Response.GetString("UTF8"), "Connection Error")
		Response.Release
	End If
End Sub

Sub GetRSS_StreamFinish(Success As Boolean, TaskId As Int)
	If Success = False Then
		Msgbox(LastException.Message, "Error")
		Return
	End If
	Dim in As InputStream
	in = File.OpenInput(File.DirInternal, "RSS.xml")
	Parser.Parse(in, "Parser")
	in.Close
End Sub

Sub Parser_StartElement(Uri As String, Name As String, Attributes As Attributes)

End Sub

Sub Parser_EndElement(Uri As String, Name As String, Text As StringBuilder)
	Dim fstHeight, secHeight, secTop As Int
	
	If Parser.Parents.IndexOf("item") > -1 Then
		If Name = "title" Then
			Title = Text.ToString
		Else If Name = "link" Then
			Link = Text.ToString
		Else If Name = "pubdate" Then
			PubDate = Text.ToString
		Else If Name = "description" Then
			Description = Text.ToString
		End If
	End If

	If Name = "item" Then
		If  lstCategory.Width < lstCategory.Height Then
			fstHeight = 60dip
			secHeight = 170dip
			secTop = 23
		Else
			fstHeight = 40dip
			secHeight = 140dip
			secTop = 3
		End If
		
		lstCategory.TwoLinesLayout.Label.Gravity = Gravity.TOP
		lstCategory.TwoLinesLayout.Label.TextSize = 10dip
		lstCategory.TwoLinesLayout.Label.Height = fstHeight
		
		lstCategory.TwoLinesLayout.ItemHeight = secHeight
		lstCategory.TwoLinesLayout.SecondLabel.TextSize = 10dip
		lstCategory.TwoLinesLayout.SecondLabel.Height = secHeight	
		lstCategory.TwoLinesLayout.SecondLabel.Top = secTop
		lstCategory.AddTwoLines2(Title, Description, Link)
	End If
End Sub

Sub InitLayout
	imgLogo.Width = 160dip
	imgLogo.Height = 58dip
	imgLogo.Top = 5dip
	imgLogo.Left = 0
	
	imgLogoRight.Width = 136dip
	imgLogoRight.Height = 58dip
	imgLogoRight.Top = 5dip
	imgLogoRight.Left = pnlHead.Width - 145dip
	
	lstCategory.Width = pnlContent.Width
	lstCategory.Height=pnlContent.Height
	lstCategory.Left=0
	lstCategory.Top=0
	lstCategory.TwoLinesLayout.Label.TextColor = Colors.ARGB(255,231,162,41)
	lstCategory.TwoLinesLayout.Label.TextSize = 16
	lstCategory.ScrollingBackgroundColor = Colors.Transparent
	lstCategory.TwoLinesLayout.ItemHeight = 60dip
	'lstCategory.TwoLinesLayout.SecondLabel.TextColor = Colors.ARGB(255,231,162,41)
	lstCategory.TwoLinesLayout.SecondLabel.TextSize = 16
	
	If general.isFavor = True OR general.globalSearch <> "" Then
		lstCategory.TwoLinesLayout.Label.TextColor = Colors.ARGB(255,231,162,41)
		lstCategory.TwoLinesLayout.Label.TextSize = 16
		'lstCategory.TwoLinesLayout.SecondLabel.TextColor = Colors.ARGB(255,231,162,41)
		lstCategory.TwoLinesLayout.SecondLabel.TextSize = 16
		lstCategory.TwoLinesAndBitmap.ImageView.Height = 24
		lstCategory.TwoLinesAndBitmap.ImageView.Width = 24
		lstCategory.TwoLinesAndBitmap.Label.Left = 40
		lstCategory.TwoLinesAndBitmap.SecondLabel.Left = 40
	End If
	
	btnExit.Width = pnlHead.Width / 4
	btnExit.Left = pnlHead.Width - btnExit.Width - 2dip
	btnExit.Top = 65dip
	btnExit.Height = 32dip
	
	btnSearch.Width = btnExit.Width
	btnSearch.Left = btnExit.Left - btnSearch.Width - 2dip
	btnSearch.Height = 32dip
	btnSearch.Top = 65dip

	txtSearch.Left = 0
	txtSearch.Width = btnSearch.Left - 2dip
	txtSearch.Top = 65dip
	txtSearch.Height = 35dip
End Sub

Sub lstCategory_ItemClick (Position As Int, Value As Object)
	If Main.categoryId = 16 Then
		StartActivity(web.OpenBrowser(Value))
	Else If Main.categoryId = 17 Then
		Select Case Value
			Case 8
				SendMail("", EmailBody, "Shia Toolkit for Android Devices", "")
			Case 9
				SendSMS("SIAT is android app for Quran,Dua,Ziaraat,Salaat,Taqeebat,Amaal etc. in arabic & english with audio. Search for “Shia Toolkit” on android market")
			Case 10
				SendMail("razamerchant81@gmail.com", "", "SIAT-v6 Feedback", "")
			Case 11
				Main.categoryId = 11
				StartActivity(Namaz)
			Case 15
				ShareFB
			Case 22
				LikeFB
		End Select
	Else
	
	Dim parseValue As String
	If general.isFavor = True OR general.globalSearch <> "" Then
		parseValue = Value
		contentId = parseValue.SubString2(0,parseValue.IndexOf("-"))
		Main.categoryId = parseValue.SubString(parseValue.IndexOf("-") + 1)
		If Main.categoryId = 14 Then isAmaal = 1 Else isAmaal = 0
	Else
		contentId =  Value
	End If
		
	Select Case Main.categoryId
		Case 3, 6, 18
			StartActivity(Namaz)
		Case 1, 2, 4, 13
			StartActivity(Content)
		Case 14
			Main.categoryId = 14
			If isAmaal = 0 Then
				isAmaal = 1
				iMonth = Value
				FillListView(14, "")
			Else
				Dim cur As Cursor
				Dim query As String 
				query = "SELECT * from amaal where iMonth_ID = " & iMonth & " and ID = " & contentId & ""
				cur = Main.SQLAmaal.ExecQuery(query)
				If cur.RowCount > 0 Then
					cur.Position = 0
					If cur.GetString("TYPE") = "D" Then StartActivity(Content)
					If cur.GetString("TYPE") = "N" Then StartActivity(Namaz)
					If cur.GetString("TYPE") = "R" Then
						Main.categoryId = cur.GetInt("REF_CAT_ID")
						contentId = cur.GetInt("REF_TRANS_ID")
						
						Select Case cur.GetInt("REF_CAT_ID")
							Case 3, 6
								StartActivity(Namaz)
							Case 1, 2, 4, 13
								StartActivity(Content)
						End Select
					End If
				End If
			End If
	End Select
	End If
End Sub

Sub txtSearch_EnterPressed
	FillListView(Main.categoryId, txtSearch.Text)
End Sub

Sub btnSearch_Click
	FillListView(Main.categoryId, txtSearch.Text)
End Sub

Sub FillListView(CategoryId As Int, SearchText As String)
	lstCategory.Clear
	Dim cur As Cursor
	Dim query As String
	Dim queryQuran As String
	Dim queryAmaal As String
	
	If general.isFavor = True Then
		FavoritesQuery(general.IsNullString(SearchText))
	Else
		If general.globalSearch <> "" Then
			query = GlobalSearchQuery(general.globalSearch)
		Else
			Select Case CategoryId
			Case 1
				If SearchText = "" Then
					query = "SELECT ID, NAME, NAME_1, DESCRIPTION FROM dua ORDER BY ID"
				Else
					query = "SELECT ID, NAME, NAME_1, DESCRIPTION FROM dua where NAME like '%" & SearchText & "%' or NAME_1 like '%" & SearchText & "%' ORDER BY ID"
				End If
			Case 2
				If SearchText = "" Then
					query = "SELECT ID, NAME, NAME_1 FROM ziarat ORDER BY ID"
				Else
					query = "SELECT ID, NAME, NAME_1 FROM ziarat where NAME like '%" & SearchText & "%' or NAME_1 like '%" & SearchText & "%' ORDER BY ID"
				End If
			Case 3
				If SearchText = "" Then
					query = "SELECT ID, NAME, NAME_1 FROM namaz ORDER BY ID"
				Else
					query = "SELECT ID, NAME, NAME_1 FROM namaz where NAME like '%" & SearchText & "%' or NAME_1 like '%" & SearchText & "%' ORDER BY ID"
				End If
			Case 4
				If SearchText = "" Then
					query = "SELECT ID, NAME, NAME_1 FROM taqibaat ORDER BY ID"
				Else
					query = "SELECT ID, NAME, NAME_1 FROM taqibaat where NAME like '%" & SearchText & "%' or NAME_1 like '%" & SearchText & "%' ORDER BY ID"
				End If
			Case 13
				If SearchText = "" Then
					queryQuran = "SELECT ID, NAME, NAME_1 FROM quran ORDER BY ID"
				Else
					queryQuran = "SELECT ID, NAME, NAME_1 FROM quran where NAME like '%" & SearchText & "%' or NAME_1 like '%" & SearchText & "%' ORDER BY ID"
				End If
			Case 14
				If isAmaal = 0 Then
					If SearchText = "" Then
						queryAmaal = "SELECT ID, NAME, NAME_1 FROM imonth ORDER BY SORT_ORDER"
					Else
						queryAmaal = "SELECT ID, NAME, NAME_1 FROM imonth where NAME like '%" & SearchText & "%' or NAME_1 like '%" & SearchText & "%' ORDER BY SORT_ORDER"
					End If
				Else
					If SearchText = "" Then
						queryAmaal = "SELECT ID, NAME, NAME_1 FROM amaal WHERE IMONTH_ID = " & iMonth & " ORDER BY SORT_ORDER"
					Else
						queryAmaal = "SELECT ID, NAME, NAME_1 FROM amaal where IMONTH_ID = " & iMonth & " AND (NAME like '%" & SearchText & "%' or NAME_1 like '%" & SearchText & "%') ORDER BY SORT_ORDER"
					End If
				End If
			Case 17
				query = "SELECT ID, NAME, ICON_NAME FROM category where parent_id = 17 ORDER BY SORT_ORDER"
			Case 18
				query = "SELECT ID, NAME, NAME_1 FROM category where parent_id = 18 ORDER BY SORT_ORDER"
			End Select
		End If
	
		If query <> "" Then
			If general.isFavor = True Then
				cur = Main.SQLMaster.ExecQuery(query)
			Else
				cur = Main.SQL1.ExecQuery(query)
			End If
		End If
		
		If queryQuran <> "" Then cur = Main.SQL2.ExecQuery(queryQuran)
		
		If queryAmaal <> "" Then cur = Main.SQLAmaal.ExecQuery(queryAmaal)
	
		For row = 0 To cur.RowCount - 1
			cur.Position = row
			
			If general.isFavor = True OR general.globalSearch <> "" Then
				lstCategory.AddTwoLinesAndBitmap2(cur.GetString("NAME"), cur.GetString("NAME_1"), LoadBitmap(File.DirAssets, cur.GetString("ICON_NAME")), cur.GetString("ID") & "-" & cur.GetString("CATEGORY_ID"))
			Else If Main.CategoryId = 17 Then
				lstCategory.TwoLinesLayout.Label.TextSize = 16
				lstCategory.TwoLinesAndBitmap.SecondLabel.Height = 0
				lstCategory.TwoLinesAndBitmap.ImageView.Height = 24
				lstCategory.TwoLinesAndBitmap.ImageView.Width = 24
				lstCategory.TwoLinesAndBitmap.Label.Left = 40
				lstCategory.AddTwoLinesAndBitmap2(cur.GetString("NAME"), "", LoadBitmap(File.DirAssets, cur.GetString("ICON_NAME")), cur.GetInt("ID"))
			Else
				lstCategory.AddTwoLines2(cur.GetString("NAME"), cur.GetString("NAME_1"), cur.GetInt("ID"))
			End If
		Next
		cur.Close
		
		If general.globalSearch <> "" Then
			queryQuran = "SELECT 13 AS CATEGORY_ID, ID, NAME, NAME_1, 'quran.png' as ICON_NAME FROM quran where NAME like '%" & general.globalSearch & "%' OR NAME_1 like '%" & general.globalSearch & "%'"	
			cur = Main.SQL2.ExecQuery(queryQuran)
			For row = 0 To cur.RowCount - 1
				cur.Position = row
				lstCategory.AddTwoLinesAndBitmap2(cur.GetString("NAME"), cur.GetString("NAME_1"), LoadBitmap(File.DirAssets, cur.GetString("ICON_NAME")), cur.GetString("ID") & "-" & cur.GetString("CATEGORY_ID"))
			Next
			cur.Close
		End If
	End If
End Sub

Sub GlobalSearchQuery(filter As String) As String
Dim query As String
query = "SELECT 1 AS CATEGORY_ID, ID, NAME, NAME_1, (Select icon_name from category where id = 1) as ICON_NAME FROM dua where NAME like '%" & filter & "%' OR NAME_1 like '%" & filter & "%'" & _
		" UNION" & _
		" SELECT 2 AS CATEGORY_ID, ID, NAME, NAME_1, (Select icon_name from category where id = 2) as ICON_NAME FROM ziarat where NAME like '%" & filter & "%' OR NAME_1 like '%" & filter & "%'" & _
		" UNION" & _
		" SELECT 3 AS CATEGORY_ID, ID, NAME, NAME_1, (Select icon_name from category where id = 3) as ICON_NAME FROM namaz where NAME like '%" & filter & "%' OR NAME_1 like '%" & filter & "%'" & _
		" UNION" & _
		" SELECT 4 AS CATEGORY_ID, ID, NAME, NAME_1, (Select icon_name from category where id = 4) as ICON_NAME FROM taqibaat where NAME like '%" & filter & "%' OR NAME_1 like '%" & filter & "%'"
Return query
End Sub

Sub FavoritesQuery(filter As String)

Dim curFav, cur As Cursor
Dim query, queryFav, queryQuran, queryAmaal As String

queryFav = "SELECT rowid, CATEGORY_ID, TRANS_ID FROM favorites"
curFav = Main.SQLMaster.ExecQuery(queryFav)

If curFav.RowCount > 0 Then
	For row = 0 To curFav.RowCount - 1
		curFav.Position = row
		Select Case curFav.GetInt("CATEGORY_ID")
			Case 1
				queryAmaal = ""
				queryQuran = ""
				query = "SELECT 1 AS CATEGORY_ID, ID, NAME, NAME_1, (Select icon_name from category where id = 1) as ICON_NAME FROM dua where ID = " & curFav.GetInt("TRANS_ID") & ""
			Case 2	
				queryAmaal = ""
				queryQuran = ""
				query = "SELECT 2 AS CATEGORY_ID, ID, NAME, NAME_1, (Select icon_name from category where id = 2) as ICON_NAME FROM ziarat where ID = " & curFav.GetInt("TRANS_ID") & ""
			Case 3
				queryAmaal = ""
				queryQuran = ""
				query = "SELECT 3 AS CATEGORY_ID, ID, NAME, NAME_1, (Select icon_name from category where id = 3) as ICON_NAME FROM namaz where ID = " & curFav.GetInt("TRANS_ID") & ""
			Case 4
				queryAmaal = ""
				queryQuran = ""
				query = "SELECT 4 AS CATEGORY_ID, ID, NAME, NAME_1, (Select icon_name from category where id = 4) as ICON_NAME FROM taqibaat where ID = " & curFav.GetInt("TRANS_ID") & ""
			Case 13
				queryAmaal = ""
				query = ""
				queryQuran = "SELECT 13 AS CATEGORY_ID, ID, NAME, NAME_1, 'quran.png' as ICON_NAME FROM quran where ID = " & curFav.GetInt("TRANS_ID") & ""
			Case 14
				queryQuran = ""
				query = ""
				queryAmaal = "SELECT 14 AS CATEGORY_ID, ID, NAME, NAME_1, 'month.ico' as ICON_NAME FROM amaal where ID = " & curFav.GetInt("TRANS_ID") & ""
		End Select
		
		If query <> "" Then
			If filter <> "" Then query = query & " and (NAME like '%" & filter & "%' OR NAME_1 like '%" & filter & "%')"
			cur = Main.SQL1.ExecQuery(query)
		End If
		If queryQuran <> "" Then
			If filter <> "" Then queryQuran = queryQuran & " and (NAME like '%" & filter & "%' OR NAME_1 like '%" & filter & "%')"
			cur = Main.SQL2.ExecQuery(queryQuran)
		End If
		If queryAmaal <> "" Then
			If filter <> "" Then queryAmaal = queryAmaal & " and (NAME like '%" & filter & "%' OR NAME_1 like '%" & filter & "%')"
			cur = Main.SQLAmaal.ExecQuery(queryAmaal)
		End If
		
		If cur.RowCount > 0 Then
			For row1 = 0 To cur.RowCount - 1
				cur.Position = row1
				lstCategory.AddTwoLinesAndBitmap2(cur.GetString("NAME"), cur.GetString("NAME_1"), LoadBitmap(File.DirAssets, cur.GetString("ICON_NAME")), cur.GetString("ID") & "-" & cur.GetString("CATEGORY_ID"))
			Next
		End If
	Next
End If
End Sub

Sub btnExit_Click
	Activity.Finish
End Sub

Sub ShareFB()
	Dim TheUrl As String
	TheUrl = "https://play.google.com/store/apps/details?id=anywheresoftware.b4a.SIAToolKit"
	Dim i As Intent     
	i.Initialize(i.ACTION_VIEW, "http://m.facebook.com/sharer.php?u=" & TheUrl)    
	i.SetType("text/plain")    
	i.PutExtra("android.intent.extra.TEXT", TheUrl)    
	i.WrapAsIntentChooser("Open browser")    
	StartActivity(i)
End Sub

Sub LikeFB()
	Dim TheLink As String
	TheLink = "http://www.facebook.com/ShiaToolkit"
	Dim i As Intent     
	i.Initialize(i.ACTION_VIEW, TheLink)    
	StartActivity(i)
End Sub

Sub SendMail(SendTo As String, SendBody As String, SendSub As String, SendAtt As String)    
	Dim ei As Email    
	ei.To.Add(SendTo.Trim)
	ei.Body = SendBody    
	ei.Subject = SendSub.Trim
	
	If SendAtt <> "" Then        
		ei.Attachments.Add(SendAtt)    
	End If        
	
	StartActivity(ei.GetIntent)
End Sub

Sub SendSMS(SendBody As String)
	Dim i As Intent
 	i.Initialize(i.ACTION_VIEW, "sms:")
 	i.PutExtra("sms_body", SendBody)
 	StartActivity(i)
 End Sub
 
 Sub EmailBody() As String
	Dim body As String
	body = "Assalamu Alaikum," & CRLF & CRLF & "Shia Isna Asheri toolkit is android based application for mobile phones, tablet PCs, net books or any device with android platform." & CRLF & CRLF & "This" & _
			" application is compilation of Complete Quran with recitation in 8 different languages, Supplications/Duas, Ziaraat, Namaz/Salaat index and method, Taqeebat, Monthly Amaal, Important Dates, Masoomeen(as) Info and other features." & CRLF & CRLF & "Most" & _
			" of the sections have arabic text, english translation, description and background, plus you have the option to play" & _
			" the audio simultaneously while reading the arabic text or translation." & CRLF & CRLF & "The" & _
			" most important feature of this application is non dependency of internet, once you have downloaded and installed the application" & _
			" on your phone or tablet PC, you don’t need internet access to read arabic text or translation or description however for audio streaming internet access is required." & CRLF & CRLF & "This" & _
			" application is absolutely free of cost and does not require any license to use or distribute." & CRLF & CRLF & "You" & _
			" can download this application from android app market by searching “Shia Toolkit”." & CRLF & CRLF & "Please" & _
			" forward it to other momineen and mominaat." & CRLF & CRLF & "Wsalam"
	Return body
End Sub